//  THIS IS AN EXAMPLE ON HOW TO WRITE AN INTERRUPT HANDLER ROUTINE
//  CALLER (INTERRUPT STUB) IN ASSEMBLER FOR VS1000B.
	

		
#define	ASM
#include <vs1000.h>

	.sect code,_SetSerialInterruptVector
	.export _SetSerialInterruptVector

	
//This fuctions sets the vector to point to caller stub...
//This is done by copying a caller opcode to the vector(!)
_SetSerialInterruptVector:
  ldx (i6)+1,null
  stx a0,(i6) ; sty a1,(i6)
  ldc serial_int_stub - 1,i7
  ldi (i7),a    //Read caller opcode from timer1_int_stub-1
  ldc 0x20+INTV_RX,i7 //Select vector... 0x0025 is Serial RX vector
  sti a,(i7)    //Insert the caller opcode to the vector
  nop           //no control change possible just after sti/ldi!
  jr
  ldx (i6)-1,a0 ; ldy (i6),a1 //executed in jr delay slot


	.sect code, serial_int_stub

	
//This is the Interrupt Caller Stub:	
  jmpi serial_int_stub,(i6)+1 // DO NOT MOVE!!!	
serial_int_stub:

  // Context Save
  stx mr0,(i6)+1    ; sty i7,(i6)
  stx lr1,(i6)+1    ; sty lr0,(i6)
  stx a2,(i6)+1     ; sty b2,(i6)
  stx c2,(i6)+1     ; sty d2,(i6)
  stx a1,(i6)+1     ; sty a0,(i6)
  add null,p,a
  stx a1,(i6)+1     ; sty a0,(i6)

  .import _SerialInterruptHandler
  call _SerialInterruptHandler
  sty i5,(i6)

  // Context Restore	
  ldy (i6)-1,i5
  ldx (i6)-1,a1     ; ldy (i6),a0
  resp a0,a1
  ldx (i6)-1,a1     ; ldy (i6),a0
  ldx (i6)-1,c2     ; ldy (i6),d2
  ldx (i6)-1,a2     ; ldy (i6),b2
  ldx (i6)-1,lr1    ; ldy (i6),lr0
  ldc INT_GLOB_EN,i7 //Acknowledge
  ldx (i6),mr0
  reti
  stx i7,(i7)       ; ldy (i6)-1,i7 //Allow interrupts
	
	.end

// Prototypes for C calling.
	
void SetSerialInterruptVector(void);
void SerialInterruptHandler(void);

