#ifndef __SPIFLASH__H__
#define __SPIFLASH__H__

/// Size of one eraseblock in blocks (8 means 4K)
/// Note: if you change this, also change the EeErase4K function and/or see all code that uses it in sbfs.c.
#define ERASEBLOCK_SIZE 8

/// First block to use for file storage. This MUST be divisible by ERASEBLOCK_SIZE
/// Note: if you change this, also change any programmer or image generator you use when preprogramming.
#define FIRST_BLOCK 32

/// Last block to use for file storage (Note: this defines the size of the flash IC) (4095 means 2 megabytes)
//#define LAST_BLOCK 4095
extern u_int32 LAST_BLOCK;

#endif /*!__SPIFLASH__H__*/
