#include <vstypes.h>
#include <vs1000.h>
#include "uartRxInt.h"

__align __y char rxBuffer[1024]; //please provide a location for this in mem_user
__y char *rxRdPtr = rxBuffer;
volatile __y char *rxWrPtr = rxBuffer;

void SetSerialInterruptVector(void);
void SerialInterruptHandler() {
	*rxWrPtr++ = PERIP(UART_DATA);
	if (rxWrPtr >= rxBuffer+sizeof(rxBuffer)) rxWrPtr = rxBuffer;
}
u_int16 CharReady() {
  register u_int16 i;
//	Disable();
	i = (rxWrPtr-rxRdPtr);
	if (i < 0) {
	    i += sizeof(rxBuffer);
	}
//	Enable();
	return i;
}
char MyGetChar() {
	register u_int16 data;
	while(!CharReady()) {
		//Wait for incoming character
	} 
	data = *rxRdPtr++;
	if (rxRdPtr >= rxBuffer+sizeof(rxBuffer)) rxRdPtr = rxBuffer;
	return data;		
}

u_int16 waitStates = 0;

auto void putch2(register char c){
	if (waitStates) {
		BusyWait10();
	}
	putch(c);
}

void Writeln(register char *s){
	while (*s) putch2(*s++);
}
__y const char hex[] = "0123456789ABCDEF";

void puthex32(register u_int32 a){
//	u_int16 i;
	static char buf[10]="00000000 ";
	register char *p = &buf[7];
	while (p>=buf){
		*p--=hex[a&0xf];
		a >>= 4;		
	}
	Writeln(buf);
}
void puthex16(register u_int16 a){
//	u_int16 i;
	static char buf[5]="0000";
	register char *p = &buf[3];
	while (p>=buf){
		*p--=hex[a&0xf];
		a >>= 4;		
	}
	Writeln(buf);
}

